/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// \brief
/// 	Camera trigger modes that can be used with parameter EPar::Cam_ExternalTriggerMode.
///
/// 	\attention The order of external trigger modes is \b not allowed to be changed.
/// 			   If further external trigger modes are needed, they must be appended.
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef RX_MANAGED_ENUM
	public enum class EExternalTriggerMode
#else
	namespace EExternalTriggerMode
	{
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/// \brief
		/// 	\copybrief Rx::Interop::Runtime30::Camera::EExternalTriggerMode
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		enum ID
#endif
{
	// Invalid value
	None = 0,
	/// The external trigger is connected to the camera.
	TriggerCam = 0x0100,
	/// DO NOT USE - The external trigger is connected to the FrameGrabber.
	TriggerFGCL = 0x0200,
};
#ifndef RX_MANAGED_ENUM
	}	// namespace
#endif
