/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2013 Raytrix GmbH. All rights reserved.
// 
// Do NOT include this file directly. Instead include the SetIpCodes.h for .NET or native accordingly!
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef RX_MANAGED_ENUM

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// 	Possible return codes for devices.
/// </summary>
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
public enum class ESetIpCode
#else
///-------------------------------------------------------------------------------------------------
/// <summary>	Values that represent ESetIpCode. </summary>
///-------------------------------------------------------------------------------------------------
namespace ESetIpCode { 

	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/// <summary>
	/// 	Possible return codes for devices.
	/// </summary>
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	enum ID
#endif
	{
		/// <summary>	The nothing additional needed, all fine. </summary>
		AllOK						= 0x0001,

		/// <summary>	The reenumeration of cameras is needed. </summary>
		ReenumerateNeeded			= 0x0002,

		/// <summary>	A camera power reset is needed. This also means you have to reenumerate. </summary>
		CameraPowerResetNeeded		= 0x0004,

		/// <summary> Everything has to be restarted. It is a bitwise | of the previous 2 </summary>
		FullRestartNeeded			= 0x0006,

		/// <summary>	Something unexpected happened. </summary>
		UnknownError				= 0x0F00,

	};
#ifndef RX_MANAGED_ENUM
} // namespace ESetIpCode
#endif

