/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// 	Defines the callback modes.
/// </summary>
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef RX_MANAGED_ENUM
	public enum class ECallbackMode
#else
	namespace ECallbackMode
	{
		enum ID
#endif
{
	/// Standard mode (default). The registered Callback returns a pointer to an image.
	/// This image is only valid during the callback.
	Standard = 0,

	/// External image mode. The registered Callback returns a pointer to memory. This pointer can be added by
	/// using SetProperty(ECamProperty::AddImageBufferPtr, pMemory). Each AddImageBufferPtr will be internally queued. After
	/// the queue is empty, all image will be dropped until the next AddImageBufferPtr call. The queue will be emptied when
	/// the stream stops or the image size changes (ROI, image format, etc.)
	ExternalImageBuffer,
};

#ifndef RX_MANAGED_ENUM
	}	// Namespace ECallbackMode
#endif
